
/**
* Implements Lowest-Variance Streamlines for Filtering of 3D Ultrasound
* Is build as static library and runs solely on Cuda. 
*/
class LVS {
public: 
	/*!
	* Calls the filter method. Is the sole entrypoint for this library.
	* @param[in] data The volume data provided as flat, normalised float array (0.0f...1.0f).
	* @param[in] width,height,depth The dimensions of the provided volume.
	* @param[in] samples The amount of samples used to calculate the variance in every direction.
	* @param[in] integrationSteps The amount of steps used to sample each streamline (in the positive and negative direction).
	* @param[in] sampleAngle The angle between each sampled direction (degrees).
	* @param[out] output The filtered volume data provided as flat, normalised float array (0.0f...1.0f).
	*/
	void filter(float *data, int width, int height, int depth, int samples, int integrationSteps, int sampleAngle, float *output);
};